unit FormLoad;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IB_Components, StdCtrls, IB_Controls, ExtCtrls, IB_Session,
  Buttons, ActnList, XPMan, IB_Grid, Menus, IB_DatasetBar,
  IB_TransactionBar, IB_ConnectionBar, ComCtrls;

type
  TForm1 = class(TForm)
    TRWords: TIB_Transaction;
    COWords: TIB_Connection;
    DSLangaugeWords: TIB_DataSource;
    dlgOpen: TOpenDialog;
    CLLanguageWords: TIB_Cursor;
    XPManifest: TXPManifest;
    actlst: TActionList;
    ActWLSelectFile: TAction;
    ActWLImport: TAction;
    pnlControl: TPanel;
    Actappexit: TAction;
    btnClose: TBitBtn;
    pmWordList: TPopupMenu;
    Exit1: TMenuItem;
    N1: TMenuItem;
    Selectfile1: TMenuItem;
    StartImport1: TMenuItem;
    pmControl: TPopupMenu;
    Exit2: TMenuItem;
    CWork: TIB_Cursor;
    pnlResults: TPanel;
    mmoResults: TMemo;
    pgc: TPageControl;
    tsStopWord: TTabSheet;
    tsTextAdd: TTabSheet;
    edtPathWordList: TEdit;
    Label2: TLabel;
    btnSelectPath: TSpeedButton;
    Label3: TLabel;
    cbCBLanguageWords: TComboBox;
    btnWordImport: TBitBtn;
    mmoAddText: TMemo;
    cbbLang: TComboBox;
    Label1: TLabel;
    Label4: TLabel;
    btnAddText: TBitBtn;
    ActTextAdd: TAction;
    tsStatistic: TTabSheet;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    LTextCount: TLabel;
    LStopWordCount: TLabel;
    LKeyWordCount: TLabel;
    btnStatRefresh: TBitBtn;
    ActStatRefresh: TAction;
    tsSearch: TTabSheet;
    Label8: TLabel;
    edtSearch: TEdit;
    btnSearch: TBitBtn;
    ActSearchStart: TAction;
    mmoSearchResult: TMemo;
    lstSearchResult: TListBox;
    Label9: TLabel;
    Label10: TLabel;
    cbbLangSearch: TComboBox;
    edtMoreThanOnce: TEdit;
    Label11: TLabel;
    chkDisplayResult: TCheckBox;
    procedure FormShow(Sender: TObject);
    procedure ActappexitExecute(Sender: TObject);
    procedure ActWLSelectFileExecute(Sender: TObject);
    procedure ActWLImportExecute(Sender: TObject);
    procedure ActTextAddExecute(Sender: TObject);
    procedure ActStatRefreshExecute(Sender: TObject);
    procedure ActSearchStartExecute(Sender: TObject);
    procedure lstSearchResultClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormShow(Sender: TObject);
begin
  COWords.Connect;

  edtSearch.Text:='';
  edtMoreThanOnce.Text:='1';
  mmoSearchResult.Lines.Text:='';
  chkDisplayResult.Checked:=True;

  mmoAddText.Lines.Clear;

  cbCBLanguageWords.Items.Clear;
  cbbLang.Items.Clear;
  cbbLangSearch.Items.Clear;
  CLLanguageWords.Active:=True;
  while not CLLanguageWords.Eof do begin
{$WARNINGS off}
    cbCBLanguageWords.AddItem(
      CLLanguageWords.FieldByName('Name').AsString,
      TObject(CLLanguageWords.FieldByName('Id').AsInteger));

    cbbLang.AddItem(
      CLLanguageWords.FieldByName('Name').AsString,
      TObject(CLLanguageWords.FieldByName('Id').AsInteger));

    cbbLangSearch.AddItem(
      CLLanguageWords.FieldByName('Name').AsString,
      TObject(CLLanguageWords.FieldByName('Id').AsInteger));
{$WARNINGS ON}
    CLLanguageWords.Next;
  end;
  cbCBLanguageWords.ItemIndex:=0;
  cbbLang.ItemIndex:=0;
  cbbLangSearch.ItemIndex:=0;

  edtPathWordList.Text:=ExtractFilePath(ParamStr(0))+'wordlist.txt';

  mmoResults.Lines.Clear;
end;

procedure TForm1.ActappexitExecute(Sender: TObject);
begin
  Close;
end;

procedure TForm1.ActWLSelectFileExecute(Sender: TObject);
begin
  with dlgOpen do begin
    FileName:=edtPathWordList.Text;
    InitialDir:=ExtractFilePath(edtPathWordList.Text);
    if Execute then
      edtPathWordList.Text:=FileName;
  end;
end;

procedure TForm1.ActWLImportExecute(Sender: TObject);
VAR
  L : TStringList;
  I : Integer;
begin
  try
    L:=TStringList.Create;
    L.LoadFromFile(edtPathWordList.Text);
    mmoResults.Lines.Add(Format('Starting StopWord import from %s',[edtPathWordList.Text]));
    with CWork do begin
      Close;
      Sql.Text:='INSERT INTO TXT_IGNORDEWORD ("IgnoreWord", "RefLanguage") '+
        'VALUES (:"IgnoreWord", :"RefLanguage")';
      Prepare;
      with cbCBLanguageWords do
{$WARNINGS OFF}
        Params[1].AsInteger:=Integer(Items.Objects[ItemIndex]);
{$WARNINGS ON}
      for i:= 0 to L.Count-1 do begin
        Params[0].AsString:=L[i];
        try
          ExecSQL;
        except
          ON E:Exception do
            mmoResults.Lines.Add(Format(' -- Error with word %s: %s',
              [L[i],E.Message]));
        end;
      end;
      Close;
    end
  finally
    FreeAndnil(L);
  end;
  mmoResults.Lines.Add('StopWord import finished');

end;

procedure TForm1.ActTextAddExecute(Sender: TObject);
VAR
  i, run : Integer;
begin
  try
    i:=StrToInt(edtMoreThanOnce.Text)
  except
      i:=1;
  end;

  with CWork do begin
    Close;
    Sql.Text:='EXECUTE PROCEDURE PRC_TXT_INSERT(:"RefTxt", :"RefLang", :"PriorText")';
    Prepare;
    with cbbLang do
{$WARNINGS OFF}
      Params[1].AsInteger:=Integer(Items.Objects[ItemIndex]);
{$WARNINGS ON}
    Params[0].AsString:=Copy(mmoAddText.Lines.Text,1,32000);
    Params[2].Clear;
    try
      for run:= 1 TO i do begin
        ExecSQL;
        mmoResults.Lines.Add(Format('Text added #%d of %d',[run,i]));
      end;  
    except
      ON E:Exception do
        mmoResults.Lines.Add(Format(' -- Error adding text: %s',
          [E.Message]));
    end;
    Close;
  end;
  mmoAddText.Lines.Clear;
end;

procedure TForm1.ActStatRefreshExecute(Sender: TObject);
begin
  LTextCount.Caption:='';
  LStopWordCount.Caption:='';
  LKeyWordCount.Caption:='';

  with CWork do begin
    try
      Close;
      Sql.Text:='SELECT Count("Id") FROM TXT_TEXT';
      Prepare;
      Open;
      LTextCount.Caption:=Format('%d.',[Fields[0].AsInteger]);

      Close;
      Sql.Text:='SELECT Count("Id") FROM TXT_IGNORDEWORD';
      Prepare;
      Open;
      LStopWordCount.Caption:=Format('%d.',[Fields[0].AsInteger]);

      Close;
      Sql.Text:='SELECT Count("Id") FROM TXT_KEYWORD';
      Prepare;
      Open;
      LKeyWordCount.Caption:=Format('%d.',[Fields[0].AsInteger]);

      mmoResults.Lines.Add('statistic refreshed');
    except
      ON E:Exception do
        mmoResults.Lines.Add(Format(' -- Error refreshing statistic: %s',
          [E.Message]));
    end;
    Close;
  end;



end;

procedure TForm1.ActSearchStartExecute(Sender: TObject);
VAR
  C : Integer;
  Start : TDateTime;
begin
  lstSearchResult.Items.Clear;
  mmoSearchResult.Lines.Clear;
  Start:=Now;
  with CWork do begin
    try
      Close;
      Sql.Text:='SELECT "RefText" FROM PRC_TXT_DOSEARCH(:"Word", :"RefLanguage")';
      Prepare;
      mmoResults.Lines.Add(Format(' after prepare %.5f sec. ',[(Now-Start)*60*60*24]));
      Params[0].AsString:=edtSearch.Text;
      with cbbLangSearch do
{$WARNINGS OFF}
        Params[1].AsInteger:=Integer(Items.Objects[ItemIndex]);
{$WARNINGS ON}
      Open;
      mmoResults.Lines.Add(Format(' after open %.5f sec. ',[(Now-Start)*60*60*24]));
      c:=0;
      while not Eof do begin
        if chkDisplayResult.Checked then
          lstSearchResult.AddItem(Fields[0].AsString,
{$WARNINGS OFF}
          TObject(Fields[0].AsInteger));
{$WARNINGS ON}
        Inc(c);
        Next;
      end;

      Close;
      mmoResults.Lines.Add(Format('%d. hits for "%s" in %.5f sec. (Plan: %s)',
        [c,edtSearch.Text,(Now-Start)*60*60*24,CWork.StatementPlan]));
    except
      ON E:Exception do
        mmoResults.Lines.Add(Format(' -- Error refreshing statistic: %s',
          [E.Message]));
    end;
    Close;
  end;
end;

procedure TForm1.lstSearchResultClick(Sender: TObject);
VAR
  txt : Integer;
begin
  txt:=0;
  with CWork do begin
    try
      Close;
      Sql.Text:='SELECT "Text" FROM TXT_TEXT WHERE "Id" = :"RefText"';
      Prepare;
{$WARNINGS OFF}
      with lstSearchResult do
        txt:=Integer(Items.Objects[ItemIndex]);
{$WARNINGS ON}
      Params[0].AsInteger:=txt;
      Open;
      mmoSearchResult.Lines.Text:=Fields[0].AsString;
      Close;
      mmoResults.Lines.Add(Format('Text #%d showed',[txt]));
    except
      ON E:Exception do
        mmoResults.Lines.Add(Format(' -- Error showing text #%d: %s',
          [txt,E.Message]));
    end;
    Close;
  end;
end;

end.
