/******************************************************************************/
/***          Generated by IBExpert 2006.12.10 18.12.2006 20:42:16          ***/
/******************************************************************************/

SET SQL DIALECT 3;

SET NAMES ISO8859_1;

--SET CLIENTLIB 'C:\Program Files\Firebird\Firebird_2_0\bin\fbclient.dll';

CREATE DATABASE '127.0.0.1:D:\db\textDB.fdb'
USER 'SYSDBA'
PAGE_SIZE 16384
DEFAULT CHARACTER SET ISO8859_1;



/******************************************************************************/
/***                         User Defined Functions                         ***/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION LTRIM
    CSTRING(255)
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'IB_UDF_ltrim' MODULE_NAME 'ib_udf';


DECLARE EXTERNAL FUNCTION RTRIM
    CSTRING(255)
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'IB_UDF_rtrim' MODULE_NAME 'ib_udf';




/******************************************************************************/
/***                                Domains                                 ***/
/******************************************************************************/

CREATE DOMAIN "DOM_Boolean" AS
SMALLINT
DEFAULT 0
CHECK ((VALUE BETWEEN 0 AND 1));

CREATE DOMAIN "DOM_CNFString" AS
VARCHAR(10000);

CREATE DOMAIN "DOM_CNFZahl" AS
BIGINT;

CREATE DOMAIN "DOM_Key" AS
BIGINT
DEFAULT 0
NOT NULL;

CREATE DOMAIN "DOM_ModDate" AS
TIMESTAMP
DEFAULT current_timestamp;

CREATE DOMAIN "DOM_ModPerson" AS
VARCHAR(18)
DEFAULT current_user;

CREATE DOMAIN "DOM_Name" AS
VARCHAR(80);

CREATE DOMAIN "DOM_Short4" AS
CHAR(4)
COLLATE DE_DE;

CREATE DOMAIN "DOM_Word" AS
VARCHAR(80);



/******************************************************************************/
/***                               Generators                               ***/
/******************************************************************************/

CREATE GENERATOR GEN_CNF_ID;
SET GENERATOR GEN_CNF_ID TO 2;

CREATE GENERATOR GEN_TXT_IGNORDEWORD_ID;
SET GENERATOR GEN_TXT_IGNORDEWORD_ID TO 771;

CREATE GENERATOR GEN_TXT_KEYWORD_ID;
SET GENERATOR GEN_TXT_KEYWORD_ID TO 0;

CREATE GENERATOR GEN_TXT_LANGUAGE;
SET GENERATOR GEN_TXT_LANGUAGE TO 161;

CREATE GENERATOR GEN_TXT_TEXTMETA_ID;
SET GENERATOR GEN_TXT_TEXTMETA_ID TO 0;

CREATE GENERATOR GEN_TXT_TEXT_ID;
SET GENERATOR GEN_TXT_TEXT_ID TO 2;

CREATE GENERATOR GEN_TXT_WORD4TEXT_ID;
SET GENERATOR GEN_TXT_WORD4TEXT_ID TO 0;



/******************************************************************************/
/***                               Exceptions                               ***/
/******************************************************************************/

CREATE EXCEPTION EX_KEYWORDINIGNORE 'Key word is in ignore word list';

CREATE EXCEPTION EX_TXTEMPTY 'Text is empty';

CREATE EXCEPTION EY_IGNOREWORDINKEY 'Ignore word is in key word list';



SET TERM ^ ; 



/******************************************************************************/
/***                           Stored Procedures                            ***/
/******************************************************************************/

CREATE PROCEDURE PRC_TXT_ADDKEYWORD (
    "Word" VARCHAR(80),
    "RefLanguage" BIGINT)
RETURNS (
    "RefKeyWord" BIGINT)
AS
BEGIN
  EXIT;
END^


CREATE PROCEDURE PRC_TXT_DOSEARCH (
    "Word" VARCHAR(80),
    "RefLanguage" BIGINT)
RETURNS (
    "RefText" BIGINT)
AS
BEGIN
  EXIT;
END^


CREATE PROCEDURE PRC_TXT_GETROOT (
    "RefText" BIGINT)
RETURNS (
    "RefRootText" BIGINT)
AS
BEGIN
  EXIT;
END^


CREATE PROCEDURE PRC_TXT_INSERT (
    "Text" VARCHAR(32000),
    "RefLanguage" BIGINT,
    "RefPriorText" BIGINT)
RETURNS (
    "RefText" BIGINT)
AS
BEGIN
  EXIT;
END^


CREATE PROCEDURE PRC_TXT_ISIGNOREWORD (
    "Word" VARCHAR(80),
    "RefLanguage" BIGINT)
RETURNS (
    "RefIgnoreWord" BIGINT)
AS
BEGIN
  EXIT;
END^


CREATE PROCEDURE PRC_TXT_ISKEYWORD (
    "Word" VARCHAR(80),
    "RefLanguage" BIGINT)
RETURNS (
    "RefKeyWord" BIGINT,
    "LastModifiedAt" TIMESTAMP)
AS
BEGIN
  EXIT;
END^


CREATE PROCEDURE PRC_TXT_UPDATEKEYWORDS (
    "RefText" BIGINT)
AS
BEGIN
  EXIT;
END^


CREATE PROCEDURE UPDATEALLKEYWORDS
AS
BEGIN
  EXIT;
END^



SET TERM ; ^


/******************************************************************************/
/***                                 Tables                                 ***/
/******************************************************************************/



CREATE TABLE CNF (
    "Id"                "DOM_Key",
    "Name"              "DOM_Name" NOT NULL,
    "Value"             "DOM_CNFString",
    "IntValue"          "DOM_CNFZahl",
    "CreatedAt"         "DOM_ModDate",
    "CreatedFrom"       "DOM_ModPerson",
    "LastModifiedAt"    "DOM_ModDate",
    "LastModifiedFrom"  "DOM_ModPerson"
);

CREATE TABLE TXT_IGNORDEWORD (
    "Id"                "DOM_Key" NOT NULL,
    "IgnoreWord"        "DOM_Word",
    "RefLanguage"       "DOM_Key",
    "CreatedAt"         "DOM_ModDate",
    "CreatedFrom"       "DOM_ModPerson",
    "LastModifiedAt"    "DOM_ModDate",
    "LastModifiedFrom"  "DOM_ModPerson"
);

CREATE TABLE TXT_KEYWORD (
    "Id"                "DOM_Key" NOT NULL,
    "KeyWord"           "DOM_Word",
    "RefLanguage"       "DOM_Key",
    "Active"            "DOM_Boolean",
    "CreatedAt"         "DOM_ModDate",
    "CreatedFrom"       "DOM_ModPerson",
    "LastModifiedAt"    "DOM_ModDate",
    "LastModifiedFrom"  "DOM_ModPerson"
);

CREATE TABLE TXT_LANGUAGE (
    "Id"                "DOM_Key",
    "Name"              "DOM_Name",
    "Short"             "DOM_Short4",
    "IsKommunikation"   "DOM_Boolean",
    "Active"            "DOM_Boolean",
    "CreatedAt"         "DOM_ModDate",
    "CreatedFrom"       "DOM_ModPerson",
    "LastModifiedAt"    "DOM_ModDate",
    "LastModifiedFrom"  "DOM_ModPerson"
);

CREATE TABLE TXT_TEXT (
    "Id"                "DOM_Key" NOT NULL,
    "Text"              VARCHAR(32000),
    "CreatedAt"         "DOM_ModDate",
    "CreatedFrom"       "DOM_ModPerson",
    "LastModifiedAt"    "DOM_ModDate",
    "LastModifiedFrom"  "DOM_ModPerson"
);

CREATE TABLE TXT_TEXTMETA (
    "Id"                "DOM_Key" NOT NULL,
    "RefText"           "DOM_Key",
    "Caption"           "DOM_Name",
    "Author"            "DOM_Name",
    "Source"            "DOM_Name",
    "Copyright"         "DOM_Name",
    "SortInfo"          "DOM_Name",
    "RefLanguage"       "DOM_Key",
    "CreatedAt"         "DOM_ModDate",
    "CreatedFrom"       "DOM_ModPerson",
    "LastModifiedAt"    "DOM_ModDate",
    "LastModifiedFrom"  "DOM_ModPerson"
);

CREATE TABLE TXT_WORD4TEXT (
    "Id"                "DOM_Key" NOT NULL,
    "RefKeyWord"        "DOM_Key",
    "RefText"           "DOM_Key",
    "CreatedAt"         "DOM_ModDate",
    "CreatedFrom"       "DOM_ModPerson",
    "LastModifiedAt"    "DOM_ModDate",
    "LastModifiedFrom"  "DOM_ModPerson"
);

INSERT INTO CNF ("Id", "Name", "Value", "IntValue", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (1, 'AutoUpdateKeyWords', '1', 1, timestamp '2006-11-04 14:05:19', 'SYSDBA', timestamp '2006-12-18 20:36:52', 'SYSDBA');
INSERT INTO CNF ("Id", "Name", "Value", "IntValue", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (2, 'UseRootsearch', '0', 0, timestamp '2006-12-18 20:36:48', 'SYSDBA', timestamp '2006-12-18 20:36:48', 'SYSDBA');

COMMIT WORK;

INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (0, 'unbekannt', NULL, 0, 0, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (1, 'Abchasisch', 'ab', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (2, 'Afar', 'aa', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (3, 'Afghanisch, Paschtu', 'ps', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (4, 'Afrikaans', 'af', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (5, 'Aimara', 'ay', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (6, 'Albanisch', 'sq', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (7, 'Amharisch', 'am', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (8, 'Arabisch', 'ar', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (9, 'Aramisch', 'ai', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (10, 'Armenisch', 'hy', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (11, 'Aserbaidschanisch', 'az', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (12, 'Assamesisch', 'as', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (13, 'Bambara', 'bm', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (14, 'Bashkir', 'ba', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (15, 'Baskisch', 'eu', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (16, 'Bengalisch', 'bn', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (17, 'Berber', 'bb', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (18, 'Bhutanisch', 'dz', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (19, 'Biharisch', 'bh', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (20, 'Birmanisch', 'my', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (21, 'Bislama', 'bi', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (22, 'Bosnien', 'bs', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (23, 'Bosnisch', 'bs', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (24, 'Bretonisch', 'br', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (25, 'Bulgarisch', 'bg', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (26, 'Chinesisch', 'zh', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (27, 'Dari', 'dr', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (28, 'Dendi', 'dn', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (29, 'Deutsch', 'de', 1, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (30, 'Dnisch', 'da', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (31, 'Englisch', 'en', 1, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (32, 'Eskimoisch', 'kl', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (33, 'Esperanto', 'eo', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (34, 'Estnisch', 'et', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (35, 'Ewe', 'ew', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (36, 'Fidschianisch', 'fj', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (37, 'Finnisch', 'fi', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (38, 'Fong', 'fn', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (39, 'Franzsisch', 'fr', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (40, 'Friesisch', 'fy', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (41, 'Frisch', 'fo', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (42, 'Galizisch', 'gl', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (43, 'Gebrdensprache', 'ge', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (44, 'Georgisch', 'ka', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (45, 'Griechisch', 'el', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (46, 'Guarani', 'gn', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (47, 'Gudschrati', 'gu', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (48, 'Haussa', 'ha', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (49, 'Hebrisch', 'iw', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (50, 'Hindi', 'hi', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (51, 'Ibo', 'ib', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (52, 'Indonesisch', 'in', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (53, 'Interlingua', 'ia', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (54, 'Interlingue', 'ie', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (55, 'Inupiak', 'ik', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (56, 'Irisch', 'ga', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (57, 'Islndisch', 'is', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (58, 'Italienisch', 'it', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (59, 'Japanisch', 'ja', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (60, 'Javanisch', 'jv', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (61, 'Jiddisch', 'ji', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (62, 'Joruba', 'yo', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (63, 'Kambodschanisch', 'km', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (64, 'Kannada', 'kn', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (65, 'Kasachisch', 'kk', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (66, 'Kashmiri', 'ks', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (67, 'Katalanisch', 'ca', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (68, 'Ketschua', 'qu', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (69, 'Kirgisisch', 'ky', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (70, 'Kirundi', 'rn', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (71, 'Klingonisch', 'kg', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (72, 'Koreanisch', 'ko', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (73, 'Korsisch', 'co', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (74, 'Kreolisch', 'cr', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (75, 'Kroatisch', 'hr', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (76, 'Kurdisch', 'ku', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (77, 'Laotisch', 'lo', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (78, 'Lateinisch', 'la', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (79, 'Lettisch', 'lv', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (80, 'Lingala', 'ln', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (81, 'Litauisch', 'lt', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (82, 'Madagassisch', 'mg', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (83, 'Malaiisch', 'ms', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (84, 'Malajalam', 'ml', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (85, 'Maledivisch', 'di', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (86, 'Maltesisch', 'mt', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (87, 'Maori', 'mi', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (88, 'Marati', 'mr', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (89, 'Mazedonisch', 'mk', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (90, 'Moldauisch', 'mo', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (91, 'Moldawisch', 'mw', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (92, 'Mongolisch', 'mn', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (93, 'Nauruisch', 'na', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (94, 'Ndebele', 'nd', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (95, 'Nepalesisch', 'ne', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (96, 'Neugriechisch', 'ng', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (97, 'Niederlndisch', 'nl', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (98, 'Norwegisch', 'no', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (99, 'Okzitanisch', 'oc', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (100, 'Orija', 'or', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (101, 'Oromo', 'om', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (102, 'Pandschabisch', 'pa', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (103, 'Paschtu, Afghanisch', 'ag', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (104, 'Persisch', 'fa', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (105, 'Polnisch', 'pl', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (106, 'Portugiesisch', 'pt', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (107, 'Ruandisch', 'rw', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (108, 'Rumnisch', 'ro', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (109, 'Russisch', 'ru', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (110, 'Rtoromanisch', 'rm', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (111, 'Samoanisch', 'sm', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (112, 'Sango', 'sg', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (113, 'Sanskrit', 'sa', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (114, 'Schottisch Glisch', 'gd', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (115, 'Schwedisch', 'sv', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (116, 'Serbisch', 'sr', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (117, 'Serbokroatisch', 'sh', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (118, 'Shona', 'sn', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (119, 'Sindhi', 'sd', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (120, 'Singhalesisch', 'si', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (121, 'Slowakisch', 'sk', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (122, 'Slowenisch', 'sl', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (123, 'Somali', 'so', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (124, 'Sotho', 'st', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (125, 'Spanisch', 'es', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (126, 'Suaheli', 'sw', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (127, 'Sundanesisch', 'su', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (128, 'Swazi', 'ss', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (129, 'Tadschikisch', 'tg', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (130, 'Tagalog', 'tl', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (131, 'Tamilisch', 'ta', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (132, 'Tatarisch', 'tt', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (133, 'Telugu', 'te', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (134, 'Thailndisch', 'th', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (135, 'Tibetisch', 'bo', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (136, 'Tigrinja', 'ti', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (137, 'Tongaisch', 'to', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (138, 'Tschechisch', 'cs', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (139, 'Tscherkessisch', 'ce', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (140, 'Tsonga', 'ts', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (141, 'Tsuana', 'tn', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (142, 'Turkmenisch', 'tk', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (143, 'Twi', 'tw', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (144, 'Trkisch', 'tr', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (145, 'Ukrainisch', 'uk', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (146, 'Ungarisch', 'hu', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (147, 'Urdu', 'ur', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (148, 'Usbekisch', 'uz', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (149, 'Vietnamesisch', 'vi', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (150, 'Volapk', 'vo', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (151, 'Walisisch', 'cy', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (152, 'Weirussisch', 'be', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (153, 'Wolof', 'wo', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (154, 'Xhosa', 'xh', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (155, 'Zulu', 'zu', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (156, 'unbekannt', '', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (157, 'sterreichisch', 'oe', 0, 1, timestamp '2006-11-04 14:22:14', 'SYSDBA', timestamp '2006-11-04 14:22:14', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (158, 'Neu Norwegisch', 'nn', 0, 0, timestamp '2006-11-13 21:33:57', 'SYSDBA', timestamp '2006-11-13 21:33:57', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (159, 'Gumuz', 'gz', 0, 0, timestamp '2006-11-13 21:34:37', 'SYSDBA', timestamp '2006-11-13 21:35:20', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (160, 'Amerikan Englisch', 'ae', 0, 0, timestamp '2006-11-13 21:39:34', 'SYSDBA', timestamp '2006-11-13 21:39:34', 'SYSDBA');
INSERT INTO TXT_LANGUAGE ("Id", "Name", "Short", "IsKommunikation", "Active", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (161, 'Plattdeutsch', 'pt', 0, 0, timestamp '2006-11-13 21:46:20', 'SYSDBA', timestamp '2006-11-13 21:46:20', 'SYSDBA');

COMMIT WORK;

INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (1, 'I', 31, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (2, 'a', 31, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (3, 'about', 31, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (4, 'an', 31, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (5, 'are', 31, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (6, 'as', 31, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (7, 'at', 31, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (8, 'be', 31, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (9, 'by', 31, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (10, 'for', 31, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (11, 'from', 31, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (12, 'how', 31, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (13, 'in', 31, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (14, 'is', 31, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (15, 'it', 31, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (16, 'of', 31, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (17, 'on', 31, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (18, 'or', 31, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (19, 'that', 31, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (20, 'the', 31, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (21, 'this', 31, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (22, 'to', 31, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (23, 'was', 31, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (24, 'what', 31, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (25, 'when', 31, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (26, 'where', 31, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (27, 'who', 31, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (28, 'will', 31, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (29, 'with', 31, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (31, 'aber', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (32, 'als', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (33, 'am', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (34, 'an', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (35, 'auch', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (36, 'auf', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (37, 'aus', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (38, 'bei', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (39, 'bin', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (40, 'bis', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (41, 'bist', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (42, 'da', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (43, 'dadurch', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (44, 'daher', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (45, 'darum', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (46, 'das', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (47, 'da', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (48, 'dass', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (49, 'dein', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (50, 'deine', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (51, 'dem', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (52, 'den', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (53, 'der', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (54, 'des', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (55, 'dessen', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (56, 'deshalb', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (57, 'die', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (58, 'dies', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (59, 'dieser', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (60, 'dieses', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (61, 'doch', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (62, 'dort', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (63, 'du', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (64, 'durch', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (65, 'ein', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (66, 'eine', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (67, 'einem', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (68, 'einen', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (69, 'einer', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (70, 'eines', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (71, 'er', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (72, 'es', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (73, 'euer', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (74, 'eure', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (75, 'fr', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (76, 'hatte', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (77, 'hatten', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (78, 'hattest', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (79, 'hattet', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (80, 'hier', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (81, 'hinter', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (82, 'ich', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (83, 'ihr', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (84, 'ihre', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (85, 'im', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (86, 'in', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (87, 'ist', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (88, 'ja', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (89, 'jede', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (90, 'jedem', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (91, 'jeden', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (92, 'jeder', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (93, 'jedes', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (94, 'jener', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (95, 'jenes', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (96, 'jetzt', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (97, 'kann', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (98, 'kannst', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (99, 'knnen', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (100, 'knnt', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (101, 'machen', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (102, 'mein', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (103, 'meine', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (104, 'mit', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (105, 'mu', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (106, 'mut', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (107, 'musst', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (108, 'mssen', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (109, 'mt', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (110, 'nach', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (111, 'nachdem', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (112, 'nein', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (113, 'nicht', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (114, 'nun', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (115, 'oder', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (116, 'seid', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (117, 'sein', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (118, 'seine', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (119, 'sich', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (120, 'sie', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (121, 'sind', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (122, 'soll', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (123, 'sollen', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (124, 'sollst', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (125, 'sollt', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (126, 'sonst', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (127, 'soweit', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (128, 'sowie', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (129, 'und', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (130, 'unser', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (131, 'unsere', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (132, 'unter', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (133, 'vom', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (134, 'von', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (135, 'vor', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (136, 'wann', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (137, 'warum', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (138, 'was', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (139, 'weiter', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (140, 'weitere', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (141, 'wenn', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (142, 'wer', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (143, 'werde', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (144, 'werden', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (145, 'werdet', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (146, 'weshalb', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (147, 'wie', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (148, 'wieder', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (149, 'wieso', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (150, 'wir', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (151, 'wird', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (152, 'wirst', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (153, 'wo', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (154, 'woher', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (155, 'wohin', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (156, 'zu', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (157, 'zum', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (158, 'zur', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (159, 'ber', 29, timestamp '2006-11-04 14:43:35', 'SYSDBA', timestamp '2006-11-04 14:43:35', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (176, 'a', 29, timestamp '2006-11-04 17:39:41', 'SYSDBA', timestamp '2006-11-04 17:39:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (177, 'a''s', 29, timestamp '2006-11-04 17:39:41', 'SYSDBA', timestamp '2006-11-04 17:39:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (178, 'able', 29, timestamp '2006-11-04 17:39:41', 'SYSDBA', timestamp '2006-11-04 17:39:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (179, 'about', 29, timestamp '2006-11-04 17:39:41', 'SYSDBA', timestamp '2006-11-04 17:39:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (180, 'above', 29, timestamp '2006-11-04 17:39:41', 'SYSDBA', timestamp '2006-11-04 17:39:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (181, 'according', 29, timestamp '2006-11-04 17:39:41', 'SYSDBA', timestamp '2006-11-04 17:39:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (182, 'accordingly', 29, timestamp '2006-11-04 17:39:41', 'SYSDBA', timestamp '2006-11-04 17:39:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (183, 'across', 29, timestamp '2006-11-04 17:39:41', 'SYSDBA', timestamp '2006-11-04 17:39:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (184, 'actually', 29, timestamp '2006-11-04 17:39:41', 'SYSDBA', timestamp '2006-11-04 17:39:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (185, 'after', 29, timestamp '2006-11-04 17:39:41', 'SYSDBA', timestamp '2006-11-04 17:39:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (186, 'afterwards', 29, timestamp '2006-11-04 17:39:41', 'SYSDBA', timestamp '2006-11-04 17:39:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (187, 'again', 29, timestamp '2006-11-04 17:39:41', 'SYSDBA', timestamp '2006-11-04 17:39:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (188, 'against', 29, timestamp '2006-11-04 17:39:41', 'SYSDBA', timestamp '2006-11-04 17:39:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (189, 'ain''t', 29, timestamp '2006-11-04 17:39:41', 'SYSDBA', timestamp '2006-11-04 17:39:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (190, 'all', 29, timestamp '2006-11-04 17:39:41', 'SYSDBA', timestamp '2006-11-04 17:39:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (191, 'allow', 29, timestamp '2006-11-04 17:39:41', 'SYSDBA', timestamp '2006-11-04 17:39:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (192, 'allows', 29, timestamp '2006-11-04 17:39:41', 'SYSDBA', timestamp '2006-11-04 17:39:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (193, 'almost', 29, timestamp '2006-11-04 17:39:41', 'SYSDBA', timestamp '2006-11-04 17:39:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (194, 'alone', 29, timestamp '2006-11-04 17:39:41', 'SYSDBA', timestamp '2006-11-04 17:39:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (195, 'along', 29, timestamp '2006-11-04 17:39:41', 'SYSDBA', timestamp '2006-11-04 17:39:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (196, 'already', 29, timestamp '2006-11-04 17:39:41', 'SYSDBA', timestamp '2006-11-04 17:39:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (197, 'also', 29, timestamp '2006-11-04 17:39:41', 'SYSDBA', timestamp '2006-11-04 17:39:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (198, 'although', 29, timestamp '2006-11-04 17:39:41', 'SYSDBA', timestamp '2006-11-04 17:39:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (199, 'always', 29, timestamp '2006-11-04 17:39:41', 'SYSDBA', timestamp '2006-11-04 17:39:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (202, 'a''s', 31, timestamp '2006-11-04 17:43:30', 'SYSDBA', timestamp '2006-11-04 17:43:30', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (203, 'able', 31, timestamp '2006-11-04 17:43:30', 'SYSDBA', timestamp '2006-11-04 17:43:30', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (205, 'above', 31, timestamp '2006-11-04 17:43:32', 'SYSDBA', timestamp '2006-11-04 17:43:32', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (206, 'according', 31, timestamp '2006-11-04 17:43:32', 'SYSDBA', timestamp '2006-11-04 17:43:32', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (207, 'accordingly', 31, timestamp '2006-11-04 17:43:32', 'SYSDBA', timestamp '2006-11-04 17:43:32', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (208, 'across', 31, timestamp '2006-11-04 17:43:32', 'SYSDBA', timestamp '2006-11-04 17:43:32', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (209, 'actually', 31, timestamp '2006-11-04 17:43:32', 'SYSDBA', timestamp '2006-11-04 17:43:32', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (210, 'after', 31, timestamp '2006-11-04 17:43:32', 'SYSDBA', timestamp '2006-11-04 17:43:32', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (211, 'afterwards', 31, timestamp '2006-11-04 17:43:32', 'SYSDBA', timestamp '2006-11-04 17:43:32', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (212, 'again', 31, timestamp '2006-11-04 17:43:32', 'SYSDBA', timestamp '2006-11-04 17:43:32', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (213, 'against', 31, timestamp '2006-11-04 17:43:32', 'SYSDBA', timestamp '2006-11-04 17:43:32', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (214, 'ain''t', 31, timestamp '2006-11-04 17:43:32', 'SYSDBA', timestamp '2006-11-04 17:43:32', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (215, 'all', 31, timestamp '2006-11-04 17:43:32', 'SYSDBA', timestamp '2006-11-04 17:43:32', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (216, 'allow', 31, timestamp '2006-11-04 17:43:32', 'SYSDBA', timestamp '2006-11-04 17:43:32', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (217, 'allows', 31, timestamp '2006-11-04 17:43:32', 'SYSDBA', timestamp '2006-11-04 17:43:32', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (218, 'almost', 31, timestamp '2006-11-04 17:43:32', 'SYSDBA', timestamp '2006-11-04 17:43:32', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (219, 'alone', 31, timestamp '2006-11-04 17:43:32', 'SYSDBA', timestamp '2006-11-04 17:43:32', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (220, 'along', 31, timestamp '2006-11-04 17:43:32', 'SYSDBA', timestamp '2006-11-04 17:43:32', 'SYSDBA');

COMMIT WORK;

INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (221, 'already', 31, timestamp '2006-11-04 17:43:32', 'SYSDBA', timestamp '2006-11-04 17:43:32', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (222, 'also', 31, timestamp '2006-11-04 17:43:32', 'SYSDBA', timestamp '2006-11-04 17:43:32', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (223, 'although', 31, timestamp '2006-11-04 17:43:32', 'SYSDBA', timestamp '2006-11-04 17:43:32', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (224, 'always', 31, timestamp '2006-11-04 17:43:32', 'SYSDBA', timestamp '2006-11-04 17:43:32', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (225, 'am', 31, timestamp '2006-11-04 17:43:32', 'SYSDBA', timestamp '2006-11-04 17:43:32', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (226, 'among', 31, timestamp '2006-11-04 17:43:32', 'SYSDBA', timestamp '2006-11-04 17:43:32', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (227, 'amongst', 31, timestamp '2006-11-04 17:43:32', 'SYSDBA', timestamp '2006-11-04 17:43:32', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (229, 'and', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (230, 'another', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (231, 'any', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (232, 'anybody', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (233, 'anyhow', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (234, 'anyone', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (235, 'anything', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (236, 'anyway', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (237, 'anyways', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (238, 'anywhere', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (239, 'apart', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (240, 'appear', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (241, 'appreciate', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (242, 'appropriate', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (244, 'aren''t', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (245, 'around', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (247, 'aside', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (248, 'ask', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (249, 'asking', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (250, 'associated', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (252, 'available', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (253, 'away', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (254, 'awfully', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (255, 'b', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (257, 'became', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (258, 'because', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (259, 'become', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (260, 'becomes', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (261, 'becoming', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (262, 'been', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (263, 'before', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (264, 'beforehand', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (265, 'behind', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (266, 'being', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (267, 'believe', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (268, 'below', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (269, 'beside', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (270, 'besides', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (271, 'best', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (272, 'better', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (273, 'between', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (274, 'beyond', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (275, 'both', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (276, 'brief', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (277, 'but', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (279, 'c', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (280, 'c''mon', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (281, 'c''s', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (282, 'came', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (283, 'can', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (284, 'can''t', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (285, 'cannot', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (286, 'cant', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (287, 'cause', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (288, 'causes', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (289, 'certain', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (290, 'certainly', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (291, 'changes', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (292, 'clearly', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (293, 'co', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (294, 'com', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (295, 'come', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (296, 'comes', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (297, 'concerning', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (298, 'consequently', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (299, 'consider', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (300, 'considering', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (301, 'contain', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (302, 'containing', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (303, 'contains', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (304, 'corresponding', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (305, 'could', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (306, 'couldn''t', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (307, 'course', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (308, 'currently', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (309, 'd', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (310, 'definitely', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (311, 'described', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (312, 'despite', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (313, 'did', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (314, 'didn''t', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (315, 'different', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (316, 'do', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (317, 'does', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (318, 'doesn''t', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (319, 'doing', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (320, 'don''t', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (321, 'done', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (322, 'down', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (323, 'downwards', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (324, 'during', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (325, 'e', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (326, 'each', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (327, 'edu', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (328, 'eg', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (329, 'eight', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (330, 'either', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (331, 'else', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (332, 'elsewhere', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (333, 'enough', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (334, 'entirely', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (335, 'especially', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (336, 'et', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (337, 'etc', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (338, 'even', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (339, 'ever', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (340, 'every', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (341, 'everybody', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (342, 'everyone', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (343, 'everything', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (344, 'everywhere', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (345, 'ex', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (346, 'exactly', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (347, 'example', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (348, 'except', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (349, 'f', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (350, 'far', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (351, 'few', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (352, 'fifth', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (353, 'first', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (354, 'five', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (355, 'followed', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (356, 'following', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (357, 'follows', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (359, 'former', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (360, 'formerly', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (361, 'forth', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (362, 'four', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (364, 'further', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (365, 'furthermore', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (366, 'g', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (367, 'get', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (368, 'gets', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (369, 'getting', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (370, 'given', 31, timestamp '2006-11-04 17:43:41', 'SYSDBA', timestamp '2006-11-04 17:43:41', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (371, 'gives', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (372, 'go', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (373, 'goes', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (374, 'going', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (375, 'gone', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (376, 'got', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (377, 'gotten', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (378, 'greetings', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (379, 'h', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (380, 'had', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (381, 'hadn''t', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (382, 'happens', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (383, 'hardly', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (384, 'has', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (385, 'hasn''t', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (386, 'have', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (387, 'haven''t', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (388, 'having', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (389, 'he', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (390, 'he''s', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (391, 'hello', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (392, 'help', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (393, 'hence', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (394, 'her', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (395, 'here', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (396, 'here''s', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (397, 'hereafter', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (398, 'hereby', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (399, 'herein', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (400, 'hereupon', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (401, 'hers', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (402, 'herself', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (403, 'hi', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (404, 'him', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (405, 'himself', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (406, 'his', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (407, 'hither', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (408, 'hopefully', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (410, 'howbeit', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (411, 'however', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (412, 'i', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (413, 'i''d', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (414, 'i''ll', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (415, 'i''m', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (416, 'i''ve', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (417, 'ie', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (418, 'if', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (419, 'ignored', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (420, 'immediate', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (422, 'inasmuch', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (423, 'inc', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (424, 'indeed', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (425, 'indicate', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (426, 'indicated', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (427, 'indicates', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (428, 'inner', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (429, 'insofar', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (430, 'instead', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');

COMMIT WORK;

INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (431, 'into', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (432, 'inward', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (434, 'isn''t', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (436, 'it''d', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (437, 'it''ll', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (438, 'it''s', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (439, 'its', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (440, 'itself', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (441, 'j', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (442, 'just', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (443, 'k', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (444, 'keep', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (445, 'keeps', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (446, 'kept', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (447, 'know', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (448, 'knows', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (449, 'known', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (450, 'l', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (451, 'last', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (452, 'lately', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (453, 'later', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (454, 'latter', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (455, 'latterly', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (456, 'least', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (457, 'less', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (458, 'lest', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (459, 'let', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (460, 'let''s', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (461, 'like', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (462, 'liked', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (463, 'likely', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (464, 'little', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (465, 'look', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (466, 'looking', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (467, 'looks', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (468, 'ltd', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (469, 'm', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (470, 'mainly', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (471, 'many', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (472, 'may', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (473, 'maybe', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (474, 'me', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (475, 'mean', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (476, 'meanwhile', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (477, 'merely', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (478, 'might', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (479, 'more', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (480, 'moreover', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (481, 'most', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (482, 'mostly', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (483, 'much', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (484, 'must', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (485, 'my', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (486, 'myself', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (487, 'n', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (488, 'name', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (489, 'namely', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (490, 'nd', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (491, 'near', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (492, 'nearly', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (493, 'necessary', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (494, 'need', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (495, 'needs', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (496, 'neither', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (497, 'never', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (498, 'nevertheless', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (499, 'new', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (500, 'next', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (501, 'nine', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (502, 'no', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (503, 'nobody', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (504, 'non', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (505, 'none', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (506, 'noone', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (507, 'nor', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (508, 'normally', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (509, 'not', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (510, 'nothing', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (511, 'novel', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (512, 'now', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (513, 'nowhere', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (514, 'o', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (515, 'obviously', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (517, 'off', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (518, 'often', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (519, 'oh', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (520, 'ok', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (521, 'okay', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (522, 'old', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (524, 'once', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (525, 'one', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (526, 'ones', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (527, 'only', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (528, 'onto', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (530, 'other', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (531, 'others', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (532, 'otherwise', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (533, 'ought', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (534, 'our', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (535, 'ours', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (536, 'ourselves', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (537, 'out', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (538, 'outside', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (539, 'over', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (540, 'overall', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (541, 'own', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (542, 'p', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (543, 'particular', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (544, 'particularly', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (545, 'per', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (546, 'perhaps', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (547, 'placed', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (548, 'please', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (549, 'plus', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (550, 'possible', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (551, 'presumably', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (552, 'probably', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (553, 'provides', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (554, 'q', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (555, 'que', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (556, 'quite', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (557, 'qv', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (558, 'r', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (559, 'rather', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (560, 'rd', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (561, 're', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (562, 'really', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (563, 'reasonably', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (564, 'regarding', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (565, 'regardless', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (566, 'regards', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (567, 'relatively', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (568, 'respectively', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (569, 'right', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (570, 's', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (571, 'said', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (572, 'same', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (573, 'saw', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (574, 'say', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (575, 'saying', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (576, 'says', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (577, 'second', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (578, 'secondly', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (579, 'see', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (580, 'seeing', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (581, 'seem', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (582, 'seemed', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (583, 'seeming', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (584, 'seems', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (585, 'seen', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (586, 'self', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (587, 'selves', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (588, 'sensible', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (589, 'sent', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (590, 'serious', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (591, 'seriously', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (592, 'seven', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (593, 'several', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (594, 'shall', 31, timestamp '2006-11-04 17:43:42', 'SYSDBA', timestamp '2006-11-04 17:43:42', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (595, 'she', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (596, 'should', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (597, 'shouldn''t', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (598, 'since', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (599, 'six', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (600, 'so', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (601, 'some', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (602, 'somebody', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (603, 'somehow', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (604, 'someone', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (605, 'something', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (606, 'sometime', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (607, 'sometimes', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (608, 'somewhat', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (609, 'somewhere', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (610, 'soon', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (611, 'sorry', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (612, 'specified', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (613, 'specify', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (614, 'specifying', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (615, 'still', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (616, 'sub', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (617, 'such', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (618, 'sup', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (619, 'sure', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (620, 't', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (621, 't''s', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (622, 'take', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (623, 'taken', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (624, 'tell', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (625, 'tends', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (626, 'th', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (627, 'than', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (628, 'thank', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (629, 'thanks', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (630, 'thanx', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (632, 'that''s', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (633, 'thats', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (635, 'their', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (636, 'theirs', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (637, 'them', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');

COMMIT WORK;

INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (638, 'themselves', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (639, 'then', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (640, 'thence', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (641, 'there', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (642, 'there''s', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (643, 'thereafter', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (644, 'thereby', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (645, 'therefore', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (646, 'therein', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (647, 'theres', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (648, 'thereupon', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (649, 'these', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (650, 'they', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (651, 'they''d', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (652, 'they''ll', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (653, 'they''re', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (654, 'they''ve', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (655, 'think', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (656, 'third', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (658, 'thorough', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (659, 'thoroughly', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (660, 'those', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (661, 'though', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (662, 'three', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (663, 'through', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (664, 'throughout', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (665, 'thru', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (666, 'thus', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (668, 'together', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (669, 'too', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (670, 'took', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (671, 'toward', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (672, 'towards', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (673, 'tried', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (674, 'tries', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (675, 'truly', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (676, 'try', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (677, 'trying', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (678, 'twice', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (679, 'two', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (680, 'u', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (681, 'un', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (682, 'under', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (683, 'unfortunately', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (684, 'unless', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (685, 'unlikely', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (686, 'until', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (687, 'unto', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (688, 'up', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (689, 'upon', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (690, 'us', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (691, 'use', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (692, 'used', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (693, 'useful', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (694, 'uses', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (695, 'using', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (696, 'usually', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (697, 'uucp', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (698, 'v', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (699, 'value', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (700, 'various', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (701, 'very', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (702, 'via', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (703, 'viz', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (704, 'vs', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (705, 'w', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (706, 'want', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (707, 'wants', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (709, 'wasn''t', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (710, 'way', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (711, 'we', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (712, 'we''d', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (713, 'we''ll', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (714, 'we''re', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (715, 'we''ve', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (716, 'welcome', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (717, 'well', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (718, 'went', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (719, 'were', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (720, 'weren''t', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (722, 'what''s', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (723, 'whatever', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (725, 'whence', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (726, 'whenever', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (728, 'where''s', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (729, 'whereafter', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (730, 'whereas', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (731, 'whereby', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (732, 'wherein', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (733, 'whereupon', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (734, 'wherever', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (735, 'whether', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (736, 'which', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (737, 'while', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (738, 'whither', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (740, 'who''s', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (741, 'whoever', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (742, 'whole', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (743, 'whom', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (744, 'whose', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (745, 'why', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (747, 'willing', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (748, 'wish', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (750, 'within', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (751, 'without', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (752, 'won''t', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (753, 'wonder', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (754, 'would', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (756, 'wouldn''t', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (757, 'x', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (758, 'y', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (759, 'yes', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (760, 'yet', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (761, 'you', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (762, 'you''d', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (763, 'you''ll', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (764, 'you''re', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (765, 'you''ve', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (766, 'your', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (767, 'yours', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (768, 'yourself', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (769, 'yourselves', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (770, 'z', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');
INSERT INTO TXT_IGNORDEWORD ("Id", "IgnoreWord", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (771, 'zero', 31, timestamp '2006-11-04 17:43:43', 'SYSDBA', timestamp '2006-11-04 17:43:43', 'SYSDBA');

COMMIT WORK;

INSERT INTO TXT_TEXT ("Id", "Text", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (0, NULL, timestamp '2006-11-14 08:23:41', 'SYSDBA', timestamp '2006-11-14 08:23:41', 'SYSDBA');

COMMIT WORK;

INSERT INTO TXT_TEXTMETA ("Id", "RefText", "Caption", "Author", "Source", "Copyright", "SortInfo", "RefLanguage", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (0, 0, NULL, NULL, NULL, NULL, NULL, 0, timestamp '2006-11-14 08:28:32', 'SYSDBA', timestamp '2006-11-14 08:28:32', 'SYSDBA');

COMMIT WORK;



/******************************************************************************/
/***                           Unique Constraints                           ***/
/******************************************************************************/

ALTER TABLE CNF ADD CONSTRAINT UNQ_CNF_NAME UNIQUE ("Name");
ALTER TABLE TXT_IGNORDEWORD ADD CONSTRAINT UNQ_TXT_IGNORDEWORD UNIQUE ("IgnoreWord", "RefLanguage");
ALTER TABLE TXT_KEYWORD ADD CONSTRAINT UNQ_TXT_KEYWORD UNIQUE ("KeyWord", "RefLanguage");


/******************************************************************************/
/***                              Primary Keys                              ***/
/******************************************************************************/

ALTER TABLE CNF ADD CONSTRAINT PK_CNF PRIMARY KEY ("Id");
ALTER TABLE TXT_IGNORDEWORD ADD CONSTRAINT PK_TXT_IGNORDEWORD PRIMARY KEY ("Id");
ALTER TABLE TXT_KEYWORD ADD CONSTRAINT PK_TXT_KEYWORD PRIMARY KEY ("Id");
ALTER TABLE TXT_LANGUAGE ADD CONSTRAINT PK_TXT_LANGUAGE PRIMARY KEY ("Id");
ALTER TABLE TXT_TEXT ADD CONSTRAINT PK_TXT_TEXT PRIMARY KEY ("Id");
ALTER TABLE TXT_TEXTMETA ADD CONSTRAINT PK_TXT_TEXTMETA PRIMARY KEY ("Id");
ALTER TABLE TXT_WORD4TEXT ADD CONSTRAINT PK_TXT_WORD4TEXT PRIMARY KEY ("Id");


/******************************************************************************/
/***                              Foreign Keys                              ***/
/******************************************************************************/

ALTER TABLE TXT_IGNORDEWORD ADD CONSTRAINT "FK_TXT_IGNORDEWORD_RefLanguage" FOREIGN KEY ("RefLanguage") REFERENCES TXT_LANGUAGE ("Id");
ALTER TABLE TXT_KEYWORD ADD CONSTRAINT "FK_TXT_KEYWORD_RefLanguage" FOREIGN KEY ("RefLanguage") REFERENCES TXT_LANGUAGE ("Id");
ALTER TABLE TXT_TEXTMETA ADD CONSTRAINT "FK_TXT_TEXTMETA_Id" FOREIGN KEY ("Id") REFERENCES TXT_TEXT ("Id") ON DELETE CASCADE;
ALTER TABLE TXT_TEXTMETA ADD CONSTRAINT "FK_TXT_TEXTMETA_RefLanguage" FOREIGN KEY ("RefLanguage") REFERENCES TXT_LANGUAGE ("Id");
ALTER TABLE TXT_WORD4TEXT ADD CONSTRAINT "FK_TXT_WORD4TEXT_RefKeyWord" FOREIGN KEY ("RefKeyWord") REFERENCES TXT_KEYWORD ("Id") ON DELETE CASCADE;
ALTER TABLE TXT_WORD4TEXT ADD CONSTRAINT "FK_TXT_WORD4TEXT_RefText" FOREIGN KEY ("RefText") REFERENCES TXT_TEXTMETA ("Id") ON DELETE CASCADE;


/******************************************************************************/
/***                                Triggers                                ***/
/******************************************************************************/


SET TERM ^ ;


/******************************************************************************/
/***                          Triggers for tables                           ***/
/******************************************************************************/



/* Trigger: CNF_BI0 */
CREATE TRIGGER CNF_BI0 FOR CNF
ACTIVE BEFORE INSERT OR UPDATE POSITION 0
AS
BEGIN
  IF ((NEW."Id" IS NULL) OR (NEW."Id" <= 0)) THEN
    NEW."Id" = GEN_ID(GEN_CNF_ID,1);

/* Setze Last* Felder */
  NEW."LastModifiedAt" = current_timestamp;
  NEW."LastModifiedFrom" = current_user;

  if (inserting) then begin
    NEW."CreatedAt" = current_timestamp;
    NEW."CreatedFrom" = current_user;
  end

  if (updating) then begin
    NEW."CreatedAt" = OLD."CreatedAt";
    NEW."CreatedFrom" = OLD."CreatedFrom";
  end
END
^

/* Trigger: CNF_BIU0 */
CREATE TRIGGER CNF_BIU0 FOR CNF
ACTIVE BEFORE INSERT OR UPDATE POSITION 1
AS
begin
  if (New."Value" <> Old."Value") then
    New."IntValue" = NULL;

  if (New."IntValue" IS NOT NULL) then
    New."Value" = New."IntValue";
end
^

/* Trigger: TXT_IGNORDEWORD_BI0 */
CREATE TRIGGER TXT_IGNORDEWORD_BI0 FOR TXT_IGNORDEWORD
ACTIVE BEFORE INSERT OR UPDATE POSITION 0
AS
BEGIN
  IF ((NEW."Id" IS NULL) OR (NEW."Id" <= 0)) THEN
    NEW."Id" = GEN_ID(GEN_TXT_IGNORDEWORD_ID,1);

/* Setze Last* Felder */
  NEW."LastModifiedAt" = current_timestamp;
  NEW."LastModifiedFrom" = current_user;

  if (inserting) then begin
    NEW."CreatedAt" = current_timestamp;
    NEW."CreatedFrom" = current_user;
  end

  if (updating) then begin
    NEW."CreatedAt" = OLD."CreatedAt";
    NEW."CreatedFrom" = OLD."CreatedFrom";
  end
END
^

/* Trigger: TXT_IGNORDEWORD_BIU1 */
CREATE TRIGGER TXT_IGNORDEWORD_BIU1 FOR TXT_IGNORDEWORD
ACTIVE BEFORE INSERT OR UPDATE POSITION 1
AS
begin
  NEW."IgnoreWord" = UPPER(LTRIM(RTRIM(NEW."IgnoreWord")));
end
^

/* Trigger: TXT_IGNORDEWORD_BIU100 */
CREATE TRIGGER TXT_IGNORDEWORD_BIU100 FOR TXT_IGNORDEWORD
ACTIVE BEFORE INSERT OR UPDATE POSITION 100
as
DECLARE VARIABLE "Dummy" BIGINT;
begin
  "Dummy" = NULL;
  SELECT FIRST 1 "Id" FROM TXT_KEYWORD WHERE "KeyWord" = UPPER(NEW."IgnoreWord")
  INTO :"Dummy";

  if ("Dummy" IS NOT NULL) then
    EXCEPTION EY_IGNOREWORDINKEY 'Ignore word '||NEW."IgnoreWord"||' is in key word list';
end
^

/* Trigger: TXT_KEYWORD_BI0 */
CREATE TRIGGER TXT_KEYWORD_BI0 FOR TXT_KEYWORD
ACTIVE BEFORE INSERT OR UPDATE POSITION 0
AS
BEGIN
  IF ((NEW."Id" IS NULL) OR (NEW."Id" <= 0)) THEN
    NEW."Id" = GEN_ID(GEN_TXT_KEYWORD_ID,1);

/* Setze Last* Felder */
  NEW."LastModifiedAt" = current_timestamp;
  NEW."LastModifiedFrom" = current_user;

  if (inserting) then begin
    NEW."CreatedAt" = current_timestamp;
    NEW."CreatedFrom" = current_user;
  end

  if (updating) then begin
    NEW."CreatedAt" = OLD."CreatedAt";
    NEW."CreatedFrom" = OLD."CreatedFrom";
  end
END
^

/* Trigger: TXT_KEYWORD_BIU100 */
CREATE TRIGGER TXT_KEYWORD_BIU100 FOR TXT_KEYWORD
ACTIVE BEFORE INSERT OR UPDATE POSITION 100
AS
DECLARE VARIABLE "Dummy" BIGINT;
begin
  "Dummy" = NULL;
  SELECT FIRST 1 "Id" FROM TXT_IGNORDEWORD WHERE "IgnoreWord" = UPPER(NEW."KeyWord")
  INTO :"Dummy";

  if ("Dummy" IS NOT NULL) then
    EXCEPTION EX_KEYWORDINIGNORE 'Key word '||NEW."KeyWord"||' is in ignore word list';
end
^

/* Trigger: TXT_KEYWORD_BUI1 */
CREATE TRIGGER TXT_KEYWORD_BUI1 FOR TXT_KEYWORD
ACTIVE BEFORE INSERT OR UPDATE POSITION 1
AS
begin
  NEW."KeyWord" = UPPER(NEW."KeyWord");
end
^

/* Trigger: TXT_LANGUAGE_BIU0 */
CREATE TRIGGER TXT_LANGUAGE_BIU0 FOR TXT_LANGUAGE
ACTIVE BEFORE INSERT OR UPDATE POSITION 0
AS
BEGIN
/* Setze ID, wenn sie noch nicht existiert */
  IF (NEW."Id" IS NULL) THEN
    NEW."Id" = GEN_ID(GEN_TXT_LANGUAGE,1);

/* Setze Last* Felder */
  NEW."LastModifiedAt" = current_timestamp;
  NEW."LastModifiedFrom" = current_user;

  if (inserting) then begin
    NEW."CreatedAt" = current_timestamp;
    NEW."CreatedFrom" = current_user;
  end

  if (updating) then begin
    NEW."CreatedAt" = OLD."CreatedAt";
    NEW."CreatedFrom" = OLD."CreatedFrom";
  end

END
^

/* Trigger: TXT_TEXTMETA_AIU0 */
CREATE TRIGGER TXT_TEXTMETA_AIU0 FOR TXT_TEXTMETA
ACTIVE AFTER INSERT OR UPDATE POSITION 0
AS
begin
  if (NEW."Id" <> OLD."Id") then
    INSERT INTO TXT_TEXT ("Id")
    VALUES (NEW."Id");

end
^

/* Trigger: TXT_TEXTMETA_BI0 */
CREATE TRIGGER TXT_TEXTMETA_BI0 FOR TXT_TEXTMETA
ACTIVE BEFORE INSERT OR UPDATE POSITION 0
AS
BEGIN
  IF ((NEW."Id" IS NULL) OR (NEW."Id" <= 0)) THEN
    NEW."Id" = GEN_ID(GEN_TXT_TEXTMETA_ID,1);

/* Setze Last* Felder */
  NEW."LastModifiedAt" = current_timestamp;
  NEW."LastModifiedFrom" = current_user;

  if (inserting) then begin
    NEW."CreatedAt" = current_timestamp;
    NEW."CreatedFrom" = current_user;
  end

  if (updating) then begin
    NEW."CreatedAt" = OLD."CreatedAt";
    NEW."CreatedFrom" = OLD."CreatedFrom";
  end
END
^

/* Trigger: TXT_TEXT_AIU0 */
CREATE TRIGGER TXT_TEXT_AIU0 FOR TXT_TEXT
ACTIVE AFTER INSERT OR UPDATE POSITION 0
AS
begin
/*  if (NEW."Id" <> OLD."Id") then
    INSERT INTO TXT_TEXTMETA ("Id")
    VALUES (NEW."Id");
  else begin */
    UPDATE TXT_TEXTMETA SET "Id" = "Id" WHERE "Id" = NEW."Id";
    if (row_count = 0) then
      INSERT INTO TXT_TEXTMETA ("Id")
      VALUES (NEW."Id");
/*  end*/
end
^

/* Trigger: TXT_TEXT_BIU0 */
CREATE TRIGGER TXT_TEXT_BIU0 FOR TXT_TEXT
ACTIVE BEFORE INSERT OR UPDATE POSITION 0
AS
BEGIN
  IF ((NEW."Id" IS NULL) OR (NEW."Id" <= 0)) THEN
    NEW."Id" = GEN_ID(GEN_TXT_TEXT_ID,1);

/* Setze Last* Felder */
  NEW."LastModifiedAt" = current_timestamp;
  NEW."LastModifiedFrom" = current_user;

  if (inserting) then begin
    NEW."CreatedAt" = current_timestamp;
    NEW."CreatedFrom" = current_user;
  end

  if (updating) then begin
    NEW."CreatedAt" = OLD."CreatedAt";
    NEW."CreatedFrom" = OLD."CreatedFrom";
  end
END
^

/* Trigger: TXT_WORD4TEXT_BI0 */
CREATE TRIGGER TXT_WORD4TEXT_BI0 FOR TXT_WORD4TEXT
ACTIVE BEFORE INSERT OR UPDATE POSITION 0
AS
BEGIN
  IF ((NEW."Id" IS NULL) OR (NEW."Id" <= 0)) THEN
    NEW."Id" = GEN_ID(GEN_TXT_IGNORDEWORD_ID,1);

/* Setze Last* Felder */
  NEW."LastModifiedAt" = current_timestamp;
  NEW."LastModifiedFrom" = current_user;

  if (inserting) then begin
    NEW."CreatedAt" = current_timestamp;
    NEW."CreatedFrom" = current_user;
  end

  if (updating) then begin
    NEW."CreatedAt" = OLD."CreatedAt";
    NEW."CreatedFrom" = OLD."CreatedFrom";
  end
END
^

SET TERM ; ^



/******************************************************************************/
/***                           Stored Procedures                            ***/
/******************************************************************************/


SET TERM ^ ;

ALTER PROCEDURE PRC_TXT_ADDKEYWORD (
    "Word" VARCHAR(80),
    "RefLanguage" BIGINT)
RETURNS (
    "RefKeyWord" BIGINT)
AS
begin
-- Check
  "Word" = LTRIM(RTRIM(UPPER("Word")));
  if (("Word" IS NULL) or ("Word" = '')) then
    EXCEPTION EX_TXTEMPTY;

-- Check, wether word is ignore word
  "RefKeyWord" = NULL;
  SELECT "RefIgnoreWord"
  FROM PRC_TXT_ISIGNOREWORD(:"Word", :"RefLanguage")
  INTO :"RefKeyWord";

  if ("RefKeyWord" IS NOT NULL) then begin
    EXCEPTION EX_KEYWORDINIGNORE 'Key word '||:"Word"||' is in ignore word list';
  end

-- Insert in keywords

  "RefKeyWord" = GEN_ID(GEN_TXT_KEYWORD_ID,1);
  INSERT INTO TXT_KEYWORD ("Id", "KeyWord", "RefLanguage", "Active")
  VALUES (:"RefKeyWord", :"Word", :"RefLanguage", 1);

  suspend;
end
^

ALTER PROCEDURE PRC_TXT_DOSEARCH (
    "Word" VARCHAR(80),
    "RefLanguage" BIGINT)
RETURNS (
    "RefText" BIGINT)
AS
DECLARE VARIABLE "RefKeyWord" BIGINT;
DECLARE VARIABLE "KeyWordLastModifiedAt" TIMESTAMP;
DECLARE VARIABLE "Text" VARCHAR(32000);
DECLARE VARIABLE "Value" BIGINT;
DECLARE VARIABLE "RefTextParent" BIGINT;
begin
  "Word" = LTRIM(RTRIM(UPPER("Word")));
  if (("Word" IS NULL) or ("Word" = '')) then
    EXCEPTION EX_TXTEMPTY;

-- 1. Search in Keywords
  "RefKeyWord" = NULL;
  SELECT "RefKeyWord", "LastModifiedAt"
  FROM PRC_TXT_ISKEYWORD(:"Word", :"RefLanguage")
  INTO :"RefKeyWord", :"KeyWordLastModifiedAt";

  if ("RefKeyWord" IS NULL) then begin
-- 2. Search in ignore words, if not found
    "RefKeyWord" = NULL;
    SELECT "RefIgnoreWord"
    FROM PRC_TXT_ISIGNOREWORD(:"Word", :"RefLanguage")
    INTO :"RefKeyWord";

    if ("RefKeyWord" IS NOT NULL) then begin
      "RefText" = -1;
      suspend;
      exit;
      -- Leave!
    end
  end

-- 3. When keyword is new = not in index
  if ("RefKeyWord" IS NULL) then begin
    -- 3.a adds keyword
    SELECT "RefKeyWord"
    FROM PRC_TXT_ADDKEYWORD(:"Word", :"RefLanguage")
    INTO :"RefKeyWord";

    -- 3.b searches in all texts for keyword
    FOR SELECT T."Id", T."Text", M."RefText"
    FROM TXT_TEXT T
    JOIN TXT_TEXTMETA M ON M."Id" = T."Id"
    WHERE M."RefLanguage" = :"RefLanguage" AND T."Text" CONTAINING :"Word"
    INTO :"RefText", :"Text", :"RefTextParent"
    DO BEGIN
      INSERT INTO TXT_WORD4TEXT ("RefKeyWord", "RefText")
      VALUES (:"RefKeyWord", :"RefText");

      /*if ("RefTextParent" > 0) then
      -- Get the root!
        SELECT "RefRootText"
        FROM PRC_TXT_GETROOT(:"RefText")
        INTO :"RefText";*/

      suspend;
    END
  end else begin
-- 4a. When keyword is known
    FOR SELECT "RefText"
    FROM TXT_WORD4TEXT
    WHERE "RefKeyWord" = :"RefKeyWord"
    INTO :"RefText"
    DO BEGIN

      -- Get the root text - if enabled
      SELECT "RefRootText"
      FROM PRC_TXT_GETROOT(:"RefText")
      INTO :"RefText";

      suspend;
    end

    SELECT "IntValue" FROM CNF WHERE CNF."Name" = 'AutoUpdateKeyWords' INTO :"Value";
    if ("Value" = 0) then begin
  
  -- 4b. serach in newer texts, when auto keyword update is off
      FOR SELECT T."Id", T."Text", M."RefText"
      FROM TXT_TEXT T
      JOIN TXT_TEXTMETA M ON M."Id" = T."Id"
      WHERE M."RefLanguage" = :"RefLanguage" AND T."Text" CONTAINING :"Word"
      AND M."LastModifiedAt" > :"KeyWordLastModifiedAt"
      INTO :"RefText", :"Text", :"RefTextParent"
      DO BEGIN
        INSERT INTO TXT_WORD4TEXT ("RefKeyWord", "RefText")
        VALUES (:"RefKeyWord", :"RefText");
  
        /*if ("RefTextParent" > 0) then
        -- Get the root!
          SELECT "RefRootText"
          FROM PRC_TXT_GETROOT(:"RefText")
          INTO :"RefText";*/
  
        suspend;
      end

  -- 4c. update keyword modification time
      UPDATE TXT_KEYWORD K SET K."Id" = K."Id" WHERE K."Id" = :"RefKeyWord";

    end
  end


end
^

ALTER PROCEDURE PRC_TXT_GETROOT (
    "RefText" BIGINT)
RETURNS (
    "RefRootText" BIGINT)
AS
DECLARE VARIABLE "Value" BIGINT;
begin
  SELECT "IntValue" FROM CNF WHERE CNF."Name" = 'AutoUpdateKeyWords' INTO :"Value";
  if ("Value" = 1) then begin -- enabled
    SELECT "RefText" FROM TXT_TEXTMETA WHERE "Id" = :"RefText" INTO :"RefRootText";
  
    if ("RefRootText" > 0) then
      SELECT "RefRootText" FROM PRC_TXT_GETROOT (:"RefRootText") INTO :"RefRootText";
    ELSE
      "RefRootText" = "RefText";
    suspend;
  end else -- disabled
    "RefRootText" = "RefText";
end
^

ALTER PROCEDURE PRC_TXT_INSERT (
    "Text" VARCHAR(32000),
    "RefLanguage" BIGINT,
    "RefPriorText" BIGINT)
RETURNS (
    "RefText" BIGINT)
AS
DECLARE VARIABLE "Value" BIGINT;
begin
  if (("RefPriorText" IS NULL) or ("RefPriorText" <= 0))  then
    "RefPriorText" = 0; -- No prior text

  -- follwoing line may cause a string truncation error. Why?
  --"Text" = LTRIM(RTRIM("Text"));

  if (("Text" IS NULL) or ("Text" = '')) then
    EXCEPTION EX_TXTEMPTY;

  "RefText" = GEN_ID(GEN_TXT_TEXT_ID,1);

  INSERT INTO TXT_TEXT ("Id", "Text")
  VALUES (:"RefText", :"Text");

  -- Insert  IN TEXTMETA should occur when TEXT is inserted via trigger
  UPDATE TXT_TEXTMETA
    SET "RefText" =  :"RefPriorText",
    "RefLanguage" = :"RefLanguage"
  WHERE "Id" = :"RefText";


  SELECT "IntValue" FROM CNF WHERE CNF."Name" = 'AutoUpdateKeyWords' INTO :"Value";
  if ("Value" = 1) then
    EXECUTE PROCEDURE PRC_TXT_UPDATEKEYWORDS("RefText");

  suspend;
end
^

ALTER PROCEDURE PRC_TXT_ISIGNOREWORD (
    "Word" VARCHAR(80),
    "RefLanguage" BIGINT)
RETURNS (
    "RefIgnoreWord" BIGINT)
AS
begin
  "Word" = LTRIM(RTRIM(UPPER("Word")));
  if (("Word" IS NULL) or ("Word" = '')) then
    EXCEPTION EX_TXTEMPTY;


  "RefIgnoreWord" = NULL;
  SELECT "Id" FROM TXT_IGNORDEWORD
    WHERE "IgnoreWord" = :"Word" AND "RefLanguage" = :"RefLanguage"
  INTO :"RefIgnoreWord";

  suspend;
end
^

ALTER PROCEDURE PRC_TXT_ISKEYWORD (
    "Word" VARCHAR(80),
    "RefLanguage" BIGINT)
RETURNS (
    "RefKeyWord" BIGINT,
    "LastModifiedAt" TIMESTAMP)
AS
begin
  "Word" = LTRIM(RTRIM(UPPER("Word")));
  if (("Word" IS NULL) or ("Word" = '')) then
    EXCEPTION EX_TXTEMPTY;

  "RefKeyWord" = NULL;
  SELECT "Id", "LastModifiedAt"
  FROM TXT_KEYWORD
  WHERE "KeyWord" = :"Word"
  AND "Active" = 1
  AND "RefLanguage" = :"RefLanguage"
  INTO :"RefKeyWord", :"LastModifiedAt";

  suspend;
end
^

ALTER PROCEDURE PRC_TXT_UPDATEKEYWORDS (
    "RefText" BIGINT)
AS
DECLARE VARIABLE "Prior" BIGINT;
DECLARE VARIABLE "RefKeyWord" BIGINT;
DECLARE VARIABLE "KeyWord" VARCHAR(80);
DECLARE VARIABLE "Text" VARCHAR(32000);
DECLARE VARIABLE "RefLanguage" BIGINT;
DECLARE VARIABLE "StartTime" TIMESTAMP;

begin
  -- Check, wether I'm not the first text in text chain
  SELECT "RefText"
  FROM TXT_TEXTMETA
  WHERE "Id" = :"RefText"
  INTO :"Prior";

  -- Check first the prior texts, so we don't forget them
  if ("Prior" <> 0) then
    EXECUTE PROCEDURE PRC_TXT_UPDATEKEYWORDS ("Prior");



  -- Do it!
-- 1. Select text
  "Text" = NULL;
  SELECT T."Text", M."RefLanguage"
  FROM TXT_TEXTMETA M
  JOIN TXT_TEXT T ON T."Id" = M."Id"
  WHERE M."Id" = :"RefText"
  INTO :"Text", :"RefLanguage";

  if ("Text" IS NULL) then
    EXCEPTION EX_TXTEMPTY 'Text # '||:"RefText"||' is empty';


-- 2. Remember start time
  "StartTime" = current_timestamp;


-- 3. for every keyword
  FOR SELECT "Id", "KeyWord"
  FROM TXT_KEYWORD
  WHERE "Active" = 1
  INTO :"RefKeyWord", :"KeyWord"
  DO BEGIN
    if ("Text" containing "KeyWord" ) then
      UPDATE TXT_WORD4TEXT
      SET "RefKeyWord" = :"RefKeyWord",
          "RefText" = :"RefText"
      WHERE "RefText" = :"RefText" AND
            "RefKeyWord" = :"RefKeyWord";

      if (ROW_COUNT = 0) then
      -- Whoen no one is hit in update, then insert
        INSERT INTO TXT_WORD4TEXT ("RefKeyWord", "RefText")
        VALUES (:"RefKeyWord", :"RefText");
  END


-- 4. Delete all WORD4TEXT entries, which are not yet updated
  DELETE FROM TXT_WORD4TEXT
  WHERE "RefText" = :"RefText" AND "LastModifiedAt" < :"StartTime" ;
end
^

ALTER PROCEDURE UPDATEALLKEYWORDS
AS
DECLARE VARIABLE "RefText" BIGINT;
begin
  FOR SELECT "Id"
  FROM TXT_TEXTMETA
  INTO :"RefText" DO
    EXECUTE PROCEDURE PRC_TXT_UPDATEKEYWORDS (:"RefText");

end
^


SET TERM ; ^


/******************************************************************************/
/***                              Descriptions                              ***/
/******************************************************************************/

UPDATE RDB$RELATIONS
SET RDB$DESCRIPTION = 'config settings'
WHERE (RDB$RELATION_NAME = 'CNF');

UPDATE RDB$RELATIONS
SET RDB$DESCRIPTION = 'Words to ignore, when searched for'
WHERE (RDB$RELATION_NAME = 'TXT_IGNORDEWORD');

UPDATE RDB$RELATIONS
SET RDB$DESCRIPTION = 'keywords = search words'
WHERE (RDB$RELATION_NAME = 'TXT_KEYWORD');

UPDATE RDB$RELATIONS
SET RDB$DESCRIPTION = 'languages'
WHERE (RDB$RELATION_NAME = 'TXT_LANGUAGE');

UPDATE RDB$RELATIONS
SET RDB$DESCRIPTION = 'original text information'
WHERE (RDB$RELATION_NAME = 'TXT_TEXT');

UPDATE RDB$RELATIONS
SET RDB$DESCRIPTION = 'meta information for text'
WHERE (RDB$RELATION_NAME = 'TXT_TEXTMETA');

UPDATE RDB$RELATIONS
SET RDB$DESCRIPTION = 'Words in text'
WHERE (RDB$RELATION_NAME = 'TXT_WORD4TEXT');



/******************************************************************************/
/***                              Descriptions                              ***/
/******************************************************************************/

UPDATE RDB$PROCEDURES
SET RDB$DESCRIPTION = '4 internal use only
Adds a keyword'
WHERE (RDB$PROCEDURE_NAME = 'PRC_TXT_ADDKEYWORD');

UPDATE RDB$PROCEDURES
SET RDB$DESCRIPTION = 'Searches for a keyword
Result of RefText = -1 means that search word is ignore word
Empty result means nothing found
Otherwise always first text block is returned'
WHERE (RDB$PROCEDURE_NAME = 'PRC_TXT_DOSEARCH');

UPDATE RDB$PROCEDURES
SET RDB$DESCRIPTION = 'Returns the root text of a text chain'
WHERE (RDB$PROCEDURE_NAME = 'PRC_TXT_GETROOT');

UPDATE RDB$PROCEDURES
SET RDB$DESCRIPTION = 'Adds a text'
WHERE (RDB$PROCEDURE_NAME = 'PRC_TXT_INSERT');

UPDATE RDB$PROCEDURES
SET RDB$DESCRIPTION = 'Checks wether word is a ignore word / stop word'
WHERE (RDB$PROCEDURE_NAME = 'PRC_TXT_ISIGNOREWORD');

UPDATE RDB$PROCEDURES
SET RDB$DESCRIPTION = 'Checks wether word is a keyword'
WHERE (RDB$PROCEDURE_NAME = 'PRC_TXT_ISKEYWORD');

UPDATE RDB$PROCEDURES
SET RDB$DESCRIPTION = 'updates the word reference list for a text'
WHERE (RDB$PROCEDURE_NAME = 'PRC_TXT_UPDATEKEYWORDS');

UPDATE RDB$PROCEDURES
SET RDB$DESCRIPTION = 'for debugging only'
WHERE (RDB$PROCEDURE_NAME = 'UPDATEALLKEYWORDS');



/******************************************************************************/
/***                              Descriptions                              ***/
/******************************************************************************/

UPDATE RDB$TRIGGERS
SET RDB$DESCRIPTION = 'care about synchronisation of values'
WHERE (RDB$TRIGGER_NAME = 'CNF_BIU0');

UPDATE RDB$TRIGGERS
SET RDB$DESCRIPTION = 'Avoid ignore words in keyword list'
WHERE (RDB$TRIGGER_NAME = 'TXT_KEYWORD_BIU100');

UPDATE RDB$TRIGGERS
SET RDB$DESCRIPTION = 'synchronize TEXTMETA and TEXT'
WHERE (RDB$TRIGGER_NAME = 'TXT_TEXTMETA_AIU0');

UPDATE RDB$TRIGGERS
SET RDB$DESCRIPTION = 'synchronize TEXT and TEXTMETA'
WHERE (RDB$TRIGGER_NAME = 'TXT_TEXT_AIU0');



/* Fields descriptions */

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'name of config value'
WHERE (RDB$RELATION_NAME = 'CNF') AND (RDB$FIELD_NAME = 'Name');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'value as string'
WHERE (RDB$RELATION_NAME = 'CNF') AND (RDB$FIELD_NAME = 'Value');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'value as integer'
WHERE (RDB$RELATION_NAME = 'CNF') AND (RDB$FIELD_NAME = 'IntValue');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'Which language'
WHERE (RDB$RELATION_NAME = 'TXT_IGNORDEWORD') AND (RDB$FIELD_NAME = 'RefLanguage');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'The Word'
WHERE (RDB$RELATION_NAME = 'TXT_KEYWORD') AND (RDB$FIELD_NAME = 'KeyWord');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'Which langauge?'
WHERE (RDB$RELATION_NAME = 'TXT_KEYWORD') AND (RDB$FIELD_NAME = 'RefLanguage');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'Should the word be used to build a search index'
WHERE (RDB$RELATION_NAME = 'TXT_KEYWORD') AND (RDB$FIELD_NAME = 'Active');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'PK'
WHERE (RDB$RELATION_NAME = 'TXT_LANGUAGE') AND (RDB$FIELD_NAME = 'Id');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'Name of the language (in German)'
WHERE (RDB$RELATION_NAME = 'TXT_LANGUAGE') AND (RDB$FIELD_NAME = 'Name');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'PK'
WHERE (RDB$RELATION_NAME = 'TXT_TEXT') AND (RDB$FIELD_NAME = 'Id');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'PK'
WHERE (RDB$RELATION_NAME = 'TXT_TEXTMETA') AND (RDB$FIELD_NAME = 'Id');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'Reference on follwoing text'
WHERE (RDB$RELATION_NAME = 'TXT_TEXTMETA') AND (RDB$FIELD_NAME = 'RefText');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'caption of the text'
WHERE (RDB$RELATION_NAME = 'TXT_TEXTMETA') AND (RDB$FIELD_NAME = 'Caption');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'author of the text'
WHERE (RDB$RELATION_NAME = 'TXT_TEXTMETA') AND (RDB$FIELD_NAME = 'Author');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'Where comes the text from?'
WHERE (RDB$RELATION_NAME = 'TXT_TEXTMETA') AND (RDB$FIELD_NAME = 'Source');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'copyright of the text'
WHERE (RDB$RELATION_NAME = 'TXT_TEXTMETA') AND (RDB$FIELD_NAME = 'Copyright');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'Info for sorting the text'
WHERE (RDB$RELATION_NAME = 'TXT_TEXTMETA') AND (RDB$FIELD_NAME = 'SortInfo');

UPDATE RDB$RELATION_FIELDS
SET RDB$DESCRIPTION = 'Which language?'
WHERE (RDB$RELATION_NAME = 'TXT_TEXTMETA') AND (RDB$FIELD_NAME = 'RefLanguage');

COMMIT WORK;



/******************************************************************************/
/***                               Privileges                               ***/
/******************************************************************************/


/* Privileges of triggers */
GRANT UPDATE, REFERENCES ON CNF TO TRIGGER CNF_BIU0;
GRANT UPDATE, REFERENCES ON TXT_IGNORDEWORD TO TRIGGER TXT_IGNORDEWORD_BI0;
GRANT UPDATE, REFERENCES ON TXT_IGNORDEWORD TO TRIGGER TXT_IGNORDEWORD_BIU1;
GRANT UPDATE, REFERENCES ON TXT_IGNORDEWORD TO TRIGGER TXT_IGNORDEWORD_BIU100;
GRANT SELECT ON TXT_KEYWORD TO TRIGGER TXT_IGNORDEWORD_BIU100;
GRANT UPDATE, REFERENCES ON TXT_KEYWORD TO TRIGGER TXT_KEYWORD_BI0;
GRANT SELECT ON TXT_IGNORDEWORD TO TRIGGER TXT_KEYWORD_BIU100;
GRANT UPDATE, REFERENCES ON TXT_KEYWORD TO TRIGGER TXT_KEYWORD_BIU100;
GRANT UPDATE, REFERENCES ON TXT_KEYWORD TO TRIGGER TXT_KEYWORD_BUI1;
GRANT INSERT ON TXT_TEXT TO TRIGGER TXT_TEXTMETA_AIU0;
GRANT UPDATE, REFERENCES ON TXT_TEXTMETA TO TRIGGER TXT_TEXTMETA_AIU0;
GRANT UPDATE, REFERENCES ON TXT_TEXTMETA TO TRIGGER TXT_TEXTMETA_BI0;
GRANT UPDATE, REFERENCES ON TXT_TEXT TO TRIGGER TXT_TEXT_AIU0;
GRANT SELECT, INSERT, UPDATE ON TXT_TEXTMETA TO TRIGGER TXT_TEXT_AIU0;
GRANT UPDATE, REFERENCES ON TXT_TEXT TO TRIGGER TXT_TEXT_BIU0;
GRANT UPDATE, REFERENCES ON TXT_WORD4TEXT TO TRIGGER TXT_WORD4TEXT_BI0;

/* Privileges of procedures */
GRANT INSERT ON TXT_KEYWORD TO PROCEDURE PRC_TXT_ADDKEYWORD;
GRANT EXECUTE ON PROCEDURE PRC_TXT_ISIGNOREWORD TO PROCEDURE PRC_TXT_ADDKEYWORD;
GRANT SELECT ON CNF TO PROCEDURE PRC_TXT_DOSEARCH;
GRANT SELECT, UPDATE ON TXT_KEYWORD TO PROCEDURE PRC_TXT_DOSEARCH;
GRANT SELECT ON TXT_TEXT TO PROCEDURE PRC_TXT_DOSEARCH;
GRANT SELECT ON TXT_TEXTMETA TO PROCEDURE PRC_TXT_DOSEARCH;
GRANT SELECT, INSERT ON TXT_WORD4TEXT TO PROCEDURE PRC_TXT_DOSEARCH;
GRANT EXECUTE ON PROCEDURE PRC_TXT_ADDKEYWORD TO PROCEDURE PRC_TXT_DOSEARCH;
GRANT EXECUTE ON PROCEDURE PRC_TXT_GETROOT TO PROCEDURE PRC_TXT_DOSEARCH;
GRANT EXECUTE ON PROCEDURE PRC_TXT_ISIGNOREWORD TO PROCEDURE PRC_TXT_DOSEARCH;
GRANT EXECUTE ON PROCEDURE PRC_TXT_ISKEYWORD TO PROCEDURE PRC_TXT_DOSEARCH;
GRANT SELECT ON CNF TO PROCEDURE PRC_TXT_GETROOT;
GRANT SELECT ON TXT_TEXT TO PROCEDURE PRC_TXT_GETROOT;
GRANT SELECT ON TXT_TEXTMETA TO PROCEDURE PRC_TXT_GETROOT;
GRANT EXECUTE ON PROCEDURE PRC_TXT_GETROOT TO PROCEDURE PRC_TXT_GETROOT;
GRANT SELECT ON CNF TO PROCEDURE PRC_TXT_INSERT;
GRANT INSERT ON TXT_TEXT TO PROCEDURE PRC_TXT_INSERT;
GRANT SELECT, INSERT, UPDATE ON TXT_TEXTMETA TO PROCEDURE PRC_TXT_INSERT;
GRANT EXECUTE ON PROCEDURE PRC_TXT_UPDATEKEYWORDS TO PROCEDURE PRC_TXT_INSERT;
GRANT SELECT ON TXT_IGNORDEWORD TO PROCEDURE PRC_TXT_ISIGNOREWORD;
GRANT SELECT ON TXT_KEYWORD TO PROCEDURE PRC_TXT_ISKEYWORD;
GRANT SELECT ON TXT_KEYWORD TO PROCEDURE PRC_TXT_UPDATEKEYWORDS;
GRANT SELECT ON TXT_TEXT TO PROCEDURE PRC_TXT_UPDATEKEYWORDS;
GRANT SELECT ON TXT_TEXTMETA TO PROCEDURE PRC_TXT_UPDATEKEYWORDS;
GRANT SELECT, INSERT, UPDATE, DELETE ON TXT_WORD4TEXT TO PROCEDURE PRC_TXT_UPDATEKEYWORDS;
GRANT EXECUTE ON PROCEDURE PRC_TXT_UPDATEKEYWORDS TO PROCEDURE PRC_TXT_UPDATEKEYWORDS;
GRANT SELECT ON TXT_TEXT TO PROCEDURE UPDATEALLKEYWORDS;
GRANT SELECT ON TXT_TEXTMETA TO PROCEDURE UPDATEALLKEYWORDS;
GRANT EXECUTE ON PROCEDURE PRC_TXT_UPDATEKEYWORDS TO PROCEDURE UPDATEALLKEYWORDS;
